#include <cppunit/extensions/HelperMacros.h>

#include "PQTest.hpp"
#include "PriorityQueue.hpp"

void PQTest::setUp()
{
  Graph graph;
  pq = new PriorityQueueT(graph);
}

void PQTest::tearDown()
{
  delete pq;
}

void PQTest::testSequence()
{
  CPPUNIT_ASSERT(pq->empty());
  pq->push(50, 1);
  CPPUNIT_ASSERT(!pq->empty());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 50, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 1, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT(pq->empty());

  pq->push(1, 80);
  pq->push(2, 30);
  pq->push(3, 50);
  pq->push(4, 60);
  pq->push(5, 70);
  pq->push(6, 90);
  pq->push(7, 10);
  pq->push(8, 20);
  pq->push(9, 40);
  //CPPUNIT_ASSERT_EQUAL((unsigned int) 50, pq->getCurrentKey(3));

  CPPUNIT_ASSERT_EQUAL((unsigned int) 7, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 10, pq->getMinKey());
  pq->deleteMin();
  //CPPUNIT_ASSERT_EQUAL((unsigned int) 20, pq->getCurrentKey(8));
  //CPPUNIT_ASSERT_EQUAL((unsigned int) 30, pq->getCurrentKey(2));
  CPPUNIT_ASSERT_EQUAL((unsigned int) 8, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 20, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 2, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 30, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 9, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 40, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 3, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 50, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 4, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 60, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 5, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 70, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 1, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 80, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 6, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 90, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT(pq->empty());

  pq->push(1, 80);
  pq->push(2, 30);
  pq->push(3, 50);
  pq->push(4, 60);
  pq->push(5, 70);
  pq->push(6, 90);
  pq->push(7, 10);
  pq->push(8, 20);
  pq->push(9, 40);

  pq->decreaseKey(1, 9);
  CPPUNIT_ASSERT_EQUAL((unsigned int) 1, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 9, pq->getMinKey());
  pq->decreaseKey(1, 70);
  pq->decreaseKey(7, 8);
  CPPUNIT_ASSERT_EQUAL((unsigned int) 7, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 8, pq->getMinKey());
  pq->deleteMin();
  CPPUNIT_ASSERT_EQUAL((unsigned int) 8, pq->getMin());
  CPPUNIT_ASSERT_EQUAL((unsigned int) 20, pq->getMinKey());

  //CPPUNIT_ASSERT_EQUAL((unsigned int) 40, pq->getCurrentKey(9));
  //CPPUNIT_ASSERT_EQUAL((unsigned int) 70, pq->getCurrentKey(1));

  pq->decreaseKey(2, 7);
  CPPUNIT_ASSERT_EQUAL((unsigned int) 2, pq->getMin());
  //CPPUNIT_ASSERT_EQUAL((unsigned int) 7, pq->getCurrentKey(2));
  CPPUNIT_ASSERT_EQUAL((unsigned int) 7, pq->getMinKey());

  //CPPUNIT_ASSERT(pq->contains(1));
  //CPPUNIT_ASSERT(pq->contains(2));
  //CPPUNIT_ASSERT(pq->contains(3));
  //CPPUNIT_ASSERT(pq->contains(4));
  //CPPUNIT_ASSERT(pq->contains(5));
  //CPPUNIT_ASSERT(pq->contains(6));
  //CPPUNIT_ASSERT(pq->contains(7));
  //CPPUNIT_ASSERT(!pq->contains(8)); // contains not even needed ;)
  //CPPUNIT_ASSERT(pq->contains(9));
  //CPPUNIT_ASSERT(!pq->contains(10));

  CPPUNIT_ASSERT(pq->isReached(1));
  CPPUNIT_ASSERT(pq->isReached(2));
  CPPUNIT_ASSERT(pq->isReached(3));
  CPPUNIT_ASSERT(pq->isReached(4));
  CPPUNIT_ASSERT(pq->isReached(5));
  CPPUNIT_ASSERT(pq->isReached(6));
  CPPUNIT_ASSERT(pq->isReached(7));
  CPPUNIT_ASSERT(pq->isReached(8));
  CPPUNIT_ASSERT(pq->isReached(9));
  CPPUNIT_ASSERT(!pq->isReached(10));
}
