#include <string>
#include <cppunit/extensions/HelperMacros.h>

#include "PriorityQueue.hpp"
#include "KStaticGraph.hpp"
#include "BasicNode.h"
#include "Edge.hpp"

#ifndef PQTEST_HPP
#define PQTEST_HPP

typedef BasicNode Node;
typedef DirectedIntegerWeightedEdge Edge;
typedef Edge::weight_type Weight;
typedef KStaticGraph<Node,Edge> Graph;
typedef PriorityQueue<Graph, unsigned int, unsigned int, std::numeric_limits<unsigned int> > PriorityQueueT;

class PQTest : public CppUnit::TestFixture
{
  CPPUNIT_TEST_SUITE(PQTest);
    CPPUNIT_TEST(testSequence);
  CPPUNIT_TEST_SUITE_END();

  public:
    void setUp();
    void tearDown();

    void testSequence();

  private:
    PriorityQueueT *pq;
};

CPPUNIT_TEST_SUITE_REGISTRATION(PQTest);

#endif // PQTEST_HPP
