/*
 * BinaryHeap.hpp
 *
 *  Created on: Apr 26, 2011
 *      Author: kobitzsch
 */

#ifndef BINARY_HEAP_HPP_
#define BINARY_HEAP_HPP_

#include <iostream>
#include <string>
#include <cstring>
#include <limits.h>

using namespace std;

//#define DEBUG

#define usercheck 0
#define safety 0
#define bottommax 35
#define w 32
#define realmax (1.78e308)

typedef short int ourchar;
#define keymax 3
#define bucketmax 65535
#define boolean bool

#define ERROR(msg) {printf("%s","ERROR: " #msg); \
printf("\n"); exit(1);}

#define INS_BEFORE(fi, la, p) { la->nxt = p;\
fi->pre = p->pre; \
p->pre = la; fi->pre->nxt = fi; }

#define OUT(p) p->nxt->pre = p->pre; \
p->pre->nxt = p->nxt;

#define START_BUCKET(bucket, thenew) { \
bucket->pre = thenew; \
bucket->nxt = thenew; \
thenew->nxt = bucket; \
thenew->pre = bucket;}

#define CLR(i,j) map_unset_bit(used [i],j);
#define MRK(i,j) map_set_bit(used [i],j);
#define USED(i,j) map_bit(used [i],j)

#define GREATER(x,y) x>y
#define GEQ(x,y) x>=y
#define LESS(x,y) x<y
#define LEQ(x,y) x<=y


//id_slot : ID Type for stored elements
//key_slot: type of key_slot used
//meta key slot: information about stored data (e.g. std::numeric_limits<key>)
template< typename GraphType, typename id_slot, typename key_slot, typename meta_key_slot >
class PriorityQueue{
private:
  PriorityQueue( const PriorityQueue & ){}  //do not copy
  void operator=( const PriorityQueue& ){}  //really, do not copy

public:
  PriorityQueue( const GraphType & graph )
  {
  }

  inline size_t size() const{
  }

  inline bool empty() const {
#ifdef DEBUG/*{{{*/
    //cout << "size: " << size() << endl;
#endif/*}}}*/
  }

  //push an element onto the heap
  void push( const id_slot & id, const key_slot & key ){
#ifdef DEBUG/*{{{*/
    cout << "push(" << id << "," << key << ")" << endl;
#endif/*}}}*/
  }

  void deleteMin(){
#ifdef DEBUG/*{{{*/
      cout << "deleteMin()" << endl;
#endif/*}}}*/
  }

  inline const id_slot & getMin() {
  }

  inline const key_slot & getMinKey() const{
  }

  inline const key_slot & getCurrentKey( id_slot id ) {
#ifdef DEBUG/*{{{*/
    cout << "getCurrentKey(" << id << ")" << endl;
#endif/*}}}*/
  }

  inline bool isReached( id_slot id ) const {
#ifdef DEBUG/*{{{*/
    cout << "isReached(" << id << ")" << endl;
#endif/*}}}*/
  }

  inline bool contains( id_slot id ) const {
  }

  void decreaseKey( id_slot id, key_slot new_key ) {
#ifdef DEBUG/*{{{*/
    cout << "decreaseKey(" << id << "," << new_key << ")" << endl;
#endif/*}}}*/
  }

  inline void increaseKey( id_slot id, key_slot new_key ) {
  }

  inline void updateKey( id_slot id, key_slot new_key ) {
  }

  inline void clear() {
  }
};


#endif /* BINARY_HEAP_HPP_ */
