/*
 * BinaryHeap.hpp
 *
 *  Created on: Apr 26, 2011
 *      Author: kobitzsch
 */

#ifndef BINARY_HEAP_HPP_
#define BINARY_HEAP_HPP_

//#define DEBUG

#include <LEDA/core/p_queue.h>
#include <LEDA/core/impl/k_heap.h>
#include <LEDA/core/impl/bin_heap.h>
#include <LEDA/core/impl/f_heap.h>
#include <LEDA/core/impl/m_heap.h>
#include <LEDA/core/impl/p_heap.h>
#include <LEDA/core/impl/r_heap.h>
#include <LEDA/core/impl/list_pq.h>

using namespace std;
using namespace leda;

//id_slot : ID Type for stored elements
//key_slot: type of key_slot used
//meta key slot: information about stored data (e.g. std::numeric_limits<key>)
template< typename GraphType, typename id_slot, typename key_slot, typename meta_key_slot >
class PriorityQueue{
private:
  PriorityQueue( const PriorityQueue & ){}  //do not copy
  void operator=( const PriorityQueue& ){}  //really, do not copy

  typedef p_queue<key_slot, id_slot, r_heap> pqueue;
  typedef typename pqueue::item pqitem;

  pqueue pq;
  pqitem** items;
  const GraphType& graph;

  struct Element {
    id_slot id;
    key_slot key;
    Element* next;
  };

  Element* list;

public:
  PriorityQueue( const GraphType & graph )
  : graph(graph)
  , pq(262144)
  {
    cout << "go" << endl;

    list = new Element();
    list->key = UINT_MAX;
    list->next = list;
  }

  inline size_t size() const{
  }

  inline bool empty() const {
#ifdef DEBUG
    //cout << "size: " << size() << endl;
#endif
    // TODO: Implement efficiently
    return false;
    //return pq.empty();
    //return b[0].next == &b[0]; ?
    //return size() == 0;
  }

  //push an element onto the heap
  void push( const id_slot & id, const key_slot & key ){
    cout << "pushing " << id << ", " << key << endl;
    Element* e = list;

    while (e->next->key < key) {
      e = e->next;

      if (e->next == list) {
        break;
      }
    }

    Element* n = new Element();
    n->id = id;
    n->key = key;
    n->next = e->next;
    e->next = n;
  }

  void deleteMin(){
    pq.del_min();
  }

  inline const id_slot & getMin() {
    Element* e = list->next;

    while (e != list) {
      cout << "a" << endl;
      pqitem i = pq.insert(e->key, e->id);
      items[e->id] = &i;
      e = e->next;
      //cout << e->key << "," << e->id << endl;
    }

    list->next = list;

    return pq.inf(pq.find_min());
  }

  inline const key_slot & getMinKey() const{
    return pq.prio(pq.find_min());
  }

  inline const key_slot & getCurrentKey( id_slot id ) {
    return pq.prio(*items[id]);
  }

  inline bool isReached( id_slot id ) const {
    return items[id] != NULL;
  }

  inline bool contains( id_slot id ) const {
  }

  void decreaseKey( id_slot id, key_slot new_key ) {
    //pq.decrease_p(*items[id], new_key);
  }

  inline void increaseKey( id_slot id, key_slot new_key ) {
  }

  inline void updateKey( id_slot id, key_slot new_key ) {
  }

  inline void clear() {
    pq.clear();
    items = new pqitem*[graph.numberOfNodes()];
  }
};


#endif /* BINARY_HEAP_HPP_ */
