#include <iostream>

#include <cppunit/TestResult.h>
#include <cppunit/TestResultCollector.h>
#include <cppunit/BriefTestProgressListener.h>
#include <cppunit/TextOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/TestRunner.h>

int main(int argc, char **argv)
{
  CppUnit::TestResult controller;
  CppUnit::TestResultCollector result;
  CppUnit::BriefTestProgressListener progress;
  controller.addListener(&result);
  controller.addListener(&progress);

  CppUnit::TextOutputter outputter(&result, std::clog);

  CppUnit::TestRunner runner;
  runner.addTest(CppUnit::TestFactoryRegistry::getRegistry().makeTest());
  runner.run(controller);

  outputter.write();

  return result.wasSuccessful() ? 0 : 1;
}
